#ifndef HATP_BELIEFMETHOD_HH_
#define HATP_BELIEFMETHOD_HH_

#include<map>
#include "Task.hh"

/** Holds all the tasks to handle the divergent beliefs.
 */
class BeliefMethod {
	public:
		/** The type of belief management task stored.
		 */
		enum Type {information, ///< The task is about the robot giving information to the human
			contradiction, ///< The task is about the robot contradicting a belief the human has
			question ///< The task is about asking the human for some information
		};

	private:
		/** The list of all belief methods (one of each type at maximum).
		 */
		std::map<Type, Task*> commTasks;
	
	public:
		void addCommTask(Type type, Task* task);
		Task* getTaskOfType(Type);
		std::string toString();
		static std::string typeToString(Type);
};

#endif //HATP_BELIEFMETHOD_HH_
